# coding: utf-8

"""
    Rightfoot Loan Repayment

    This API provides loan repayment. You can find out more about Rightfoot at [docs.rightfoot.com](https://docs.rightfoot.com).   # noqa: E501

    OpenAPI spec version: 1.3.1
    Contact: engineering@rightfoot.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class Beneficiary(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'uuid': 'str',
        'first_name': 'str',
        'last_name': 'str',
        'date_of_birth': 'date',
        'phone_number': 'str',
        'mailing_address': 'MailingAddress',
        'payments_enabled': 'bool'
    }

    attribute_map = {
        'uuid': 'uuid',
        'first_name': 'firstName',
        'last_name': 'lastName',
        'date_of_birth': 'dateOfBirth',
        'phone_number': 'phoneNumber',
        'mailing_address': 'mailingAddress',
        'payments_enabled': 'paymentsEnabled'
    }

    def __init__(self, uuid=None, first_name=None, last_name=None, date_of_birth=None, phone_number=None, mailing_address=None, payments_enabled=None):  # noqa: E501
        """Beneficiary - a model defined in Swagger"""  # noqa: E501
        self._uuid = None
        self._first_name = None
        self._last_name = None
        self._date_of_birth = None
        self._phone_number = None
        self._mailing_address = None
        self._payments_enabled = None
        self.discriminator = None
        if uuid is not None:
            self.uuid = uuid
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if date_of_birth is not None:
            self.date_of_birth = date_of_birth
        if phone_number is not None:
            self.phone_number = phone_number
        if mailing_address is not None:
            self.mailing_address = mailing_address
        if payments_enabled is not None:
            self.payments_enabled = payments_enabled

    @property
    def uuid(self):
        """Gets the uuid of this Beneficiary.  # noqa: E501

        Unique identifier generated by Rightfoot.  # noqa: E501

        :return: The uuid of this Beneficiary.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this Beneficiary.

        Unique identifier generated by Rightfoot.  # noqa: E501

        :param uuid: The uuid of this Beneficiary.  # noqa: E501
        :type: str
        """

        self._uuid = uuid

    @property
    def first_name(self):
        """Gets the first_name of this Beneficiary.  # noqa: E501

        The given name of the beneficiary.  # noqa: E501

        :return: The first_name of this Beneficiary.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this Beneficiary.

        The given name of the beneficiary.  # noqa: E501

        :param first_name: The first_name of this Beneficiary.  # noqa: E501
        :type: str
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this Beneficiary.  # noqa: E501

        The family name of the beneficiary.  # noqa: E501

        :return: The last_name of this Beneficiary.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this Beneficiary.

        The family name of the beneficiary.  # noqa: E501

        :param last_name: The last_name of this Beneficiary.  # noqa: E501
        :type: str
        """

        self._last_name = last_name

    @property
    def date_of_birth(self):
        """Gets the date_of_birth of this Beneficiary.  # noqa: E501

        Birth date for the beneficiary formatted as YYYY-MM-DD.  # noqa: E501

        :return: The date_of_birth of this Beneficiary.  # noqa: E501
        :rtype: date
        """
        return self._date_of_birth

    @date_of_birth.setter
    def date_of_birth(self, date_of_birth):
        """Sets the date_of_birth of this Beneficiary.

        Birth date for the beneficiary formatted as YYYY-MM-DD.  # noqa: E501

        :param date_of_birth: The date_of_birth of this Beneficiary.  # noqa: E501
        :type: date
        """

        self._date_of_birth = date_of_birth

    @property
    def phone_number(self):
        """Gets the phone_number of this Beneficiary.  # noqa: E501

        Phone number for the beneficiary formatted internationally with spacing such as +1 555 555 5555.   # noqa: E501

        :return: The phone_number of this Beneficiary.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this Beneficiary.

        Phone number for the beneficiary formatted internationally with spacing such as +1 555 555 5555.   # noqa: E501

        :param phone_number: The phone_number of this Beneficiary.  # noqa: E501
        :type: str
        """

        self._phone_number = phone_number

    @property
    def mailing_address(self):
        """Gets the mailing_address of this Beneficiary.  # noqa: E501


        :return: The mailing_address of this Beneficiary.  # noqa: E501
        :rtype: MailingAddress
        """
        return self._mailing_address

    @mailing_address.setter
    def mailing_address(self, mailing_address):
        """Sets the mailing_address of this Beneficiary.


        :param mailing_address: The mailing_address of this Beneficiary.  # noqa: E501
        :type: MailingAddress
        """

        self._mailing_address = mailing_address

    @property
    def payments_enabled(self):
        """Gets the payments_enabled of this Beneficiary.  # noqa: E501

        Indicates if the `Beneficiary` is eligible for payments to be processed. Deprecated: Query for loans held by the `Beneficiary` instead.   # noqa: E501

        :return: The payments_enabled of this Beneficiary.  # noqa: E501
        :rtype: bool
        """
        return self._payments_enabled

    @payments_enabled.setter
    def payments_enabled(self, payments_enabled):
        """Sets the payments_enabled of this Beneficiary.

        Indicates if the `Beneficiary` is eligible for payments to be processed. Deprecated: Query for loans held by the `Beneficiary` instead.   # noqa: E501

        :param payments_enabled: The payments_enabled of this Beneficiary.  # noqa: E501
        :type: bool
        """

        self._payments_enabled = payments_enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Beneficiary, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Beneficiary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
