# coding: utf-8

"""
    Rightfoot Loan Repayment

    This API provides loan repayment. You can find out more about Rightfoot at [docs.rightfoot.com](https://docs.rightfoot.com).   # noqa: E501

    OpenAPI spec version: 1.3.1
    Contact: engineering@rightfoot.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class CreateFundingSourceRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'benefactor_uuid': 'str',
        'beneficiary_uuid': 'str',
        'organization_uuid': 'str',
        'email_address': 'str',
        'plaid_public_token': 'str',
        'account_id': 'str',
        'dwolla_processor_token': 'str',
        'routing_number': 'str',
        'account_number': 'str'
    }

    attribute_map = {
        'benefactor_uuid': 'benefactorUuid',
        'beneficiary_uuid': 'beneficiaryUuid',
        'organization_uuid': 'organizationUuid',
        'email_address': 'emailAddress',
        'plaid_public_token': 'plaidPublicToken',
        'account_id': 'accountId',
        'dwolla_processor_token': 'dwollaProcessorToken',
        'routing_number': 'routingNumber',
        'account_number': 'accountNumber'
    }

    def __init__(self, benefactor_uuid=None, beneficiary_uuid=None, organization_uuid=None, email_address=None, plaid_public_token=None, account_id=None, dwolla_processor_token=None, routing_number=None, account_number=None):  # noqa: E501
        """CreateFundingSourceRequest - a model defined in Swagger"""  # noqa: E501
        self._benefactor_uuid = None
        self._beneficiary_uuid = None
        self._organization_uuid = None
        self._email_address = None
        self._plaid_public_token = None
        self._account_id = None
        self._dwolla_processor_token = None
        self._routing_number = None
        self._account_number = None
        self.discriminator = None
        if benefactor_uuid is not None:
            self.benefactor_uuid = benefactor_uuid
        if beneficiary_uuid is not None:
            self.beneficiary_uuid = beneficiary_uuid
        if organization_uuid is not None:
            self.organization_uuid = organization_uuid
        if email_address is not None:
            self.email_address = email_address
        if plaid_public_token is not None:
            self.plaid_public_token = plaid_public_token
        if account_id is not None:
            self.account_id = account_id
        if dwolla_processor_token is not None:
            self.dwolla_processor_token = dwolla_processor_token
        if routing_number is not None:
            self.routing_number = routing_number
        if account_number is not None:
            self.account_number = account_number

    @property
    def benefactor_uuid(self):
        """Gets the benefactor_uuid of this CreateFundingSourceRequest.  # noqa: E501

        Unique identifier generated by Rightfoot for Benefactor. If not provided, organizationUuid must be set.   # noqa: E501

        :return: The benefactor_uuid of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._benefactor_uuid

    @benefactor_uuid.setter
    def benefactor_uuid(self, benefactor_uuid):
        """Sets the benefactor_uuid of this CreateFundingSourceRequest.

        Unique identifier generated by Rightfoot for Benefactor. If not provided, organizationUuid must be set.   # noqa: E501

        :param benefactor_uuid: The benefactor_uuid of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._benefactor_uuid = benefactor_uuid

    @property
    def beneficiary_uuid(self):
        """Gets the beneficiary_uuid of this CreateFundingSourceRequest.  # noqa: E501

        Unique identifier generated by Rightfoot for Beneficiary. If not provided, organizationUuid must be set.   # noqa: E501

        :return: The beneficiary_uuid of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._beneficiary_uuid

    @beneficiary_uuid.setter
    def beneficiary_uuid(self, beneficiary_uuid):
        """Sets the beneficiary_uuid of this CreateFundingSourceRequest.

        Unique identifier generated by Rightfoot for Beneficiary. If not provided, organizationUuid must be set.   # noqa: E501

        :param beneficiary_uuid: The beneficiary_uuid of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._beneficiary_uuid = beneficiary_uuid

    @property
    def organization_uuid(self):
        """Gets the organization_uuid of this CreateFundingSourceRequest.  # noqa: E501

        Unique identifier generated by Rightfoot for Organization. If not provided, beneficiaryUuid must be set.   # noqa: E501

        :return: The organization_uuid of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._organization_uuid

    @organization_uuid.setter
    def organization_uuid(self, organization_uuid):
        """Sets the organization_uuid of this CreateFundingSourceRequest.

        Unique identifier generated by Rightfoot for Organization. If not provided, beneficiaryUuid must be set.   # noqa: E501

        :param organization_uuid: The organization_uuid of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._organization_uuid = organization_uuid

    @property
    def email_address(self):
        """Gets the email_address of this CreateFundingSourceRequest.  # noqa: E501

        Valid email address, which can be used to reach the user. Rightfoot and its partners do not conduct regular communication with end-users. Regulations require bank partner to have the ability to contact the end-user.   # noqa: E501

        :return: The email_address of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._email_address

    @email_address.setter
    def email_address(self, email_address):
        """Sets the email_address of this CreateFundingSourceRequest.

        Valid email address, which can be used to reach the user. Rightfoot and its partners do not conduct regular communication with end-users. Regulations require bank partner to have the ability to contact the end-user.   # noqa: E501

        :param email_address: The email_address of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._email_address = email_address

    @property
    def plaid_public_token(self):
        """Gets the plaid_public_token of this CreateFundingSourceRequest.  # noqa: E501

        Public token provided by Plaid Link representing the beneficiary’s bank account. Grants Rightfoot permission to draw from the account backing this token. Either this and accountId are required or dwollaProcessorToken is required.   # noqa: E501

        :return: The plaid_public_token of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._plaid_public_token

    @plaid_public_token.setter
    def plaid_public_token(self, plaid_public_token):
        """Sets the plaid_public_token of this CreateFundingSourceRequest.

        Public token provided by Plaid Link representing the beneficiary’s bank account. Grants Rightfoot permission to draw from the account backing this token. Either this and accountId are required or dwollaProcessorToken is required.   # noqa: E501

        :param plaid_public_token: The plaid_public_token of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._plaid_public_token = plaid_public_token

    @property
    def account_id(self):
        """Gets the account_id of this CreateFundingSourceRequest.  # noqa: E501

        Account ID from Plaid Link when a user selects a specific checking or savings bank account from the bank institution they log into. Either this and plaidPublicToken are required or dwollaProcessorToken is required.   # noqa: E501

        :return: The account_id of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this CreateFundingSourceRequest.

        Account ID from Plaid Link when a user selects a specific checking or savings bank account from the bank institution they log into. Either this and plaidPublicToken are required or dwollaProcessorToken is required.   # noqa: E501

        :param account_id: The account_id of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._account_id = account_id

    @property
    def dwolla_processor_token(self):
        """Gets the dwolla_processor_token of this CreateFundingSourceRequest.  # noqa: E501

        Dwolla Processor Token generated from a Plaid Auth access token owned by the API application. Grants Rightfoot permission to draw from the account backing this token. Either this or plaidPublicToken and accountId is required.   # noqa: E501

        :return: The dwolla_processor_token of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._dwolla_processor_token

    @dwolla_processor_token.setter
    def dwolla_processor_token(self, dwolla_processor_token):
        """Sets the dwolla_processor_token of this CreateFundingSourceRequest.

        Dwolla Processor Token generated from a Plaid Auth access token owned by the API application. Grants Rightfoot permission to draw from the account backing this token. Either this or plaidPublicToken and accountId is required.   # noqa: E501

        :param dwolla_processor_token: The dwolla_processor_token of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._dwolla_processor_token = dwolla_processor_token

    @property
    def routing_number(self):
        """Gets the routing_number of this CreateFundingSourceRequest.  # noqa: E501

        The bank account number. Note: The account number is validated to check if it is a numeric string of 4-17 digits.   # noqa: E501

        :return: The routing_number of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._routing_number

    @routing_number.setter
    def routing_number(self, routing_number):
        """Sets the routing_number of this CreateFundingSourceRequest.

        The bank account number. Note: The account number is validated to check if it is a numeric string of 4-17 digits.   # noqa: E501

        :param routing_number: The routing_number of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._routing_number = routing_number

    @property
    def account_number(self):
        """Gets the account_number of this CreateFundingSourceRequest.  # noqa: E501

        A bank routing number that identifies a bank or credit union in the U.S.   # noqa: E501

        :return: The account_number of this CreateFundingSourceRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_number

    @account_number.setter
    def account_number(self, account_number):
        """Sets the account_number of this CreateFundingSourceRequest.

        A bank routing number that identifies a bank or credit union in the U.S.   # noqa: E501

        :param account_number: The account_number of this CreateFundingSourceRequest.  # noqa: E501
        :type: str
        """

        self._account_number = account_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateFundingSourceRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateFundingSourceRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
